#!/usr/bin/ruby -Ks
#
require '/opt/yklook/swing'
require '/opt/yklook/swingsplitpane'
require '/opt/yklook/swingtabpane'
require '/opt/yklook/swingtable'
require '/opt/yklook/swingtree'

class Tegami < YKLookMain

	def yki_size()
		return [660, 420]
	end

	def yki_title()
		return '莆'
	end

	def yki_make_display()
		sent = [ "Mς", nil ]
		recv = [ "M", nil ]
		wife = [ "Ƒ/e", "q", nil ]
		pupl = [ "k/剺", nil ]
		misc = [ "̑", nil ]

		tree  = YKLookTree.new( [sent, recv, wife, pupl, misc], "Ėڟ" )
		table = YKLookTable.new( ["", "薼", "t"] )
		text  = YKLookTextArea.new()
		spHor = YKLookSplitPane.new( 'H' )
		spVer = YKLookSplitPane.new( 'V' )

		tree .yk_set_preferred_size( 120, 130 )
		table.yk_set_preferred_size( 330, 130 )
		text .yk_set_preferred_size( 580, 245 )

		spHor.yk_add( tree  )
		spHor.yk_add( table )
		spVer.yk_add( spHor )
		spVer.yk_add( text  )

		spHor.yk_set_onetouch_expandable( true )
		spVer.yk_set_onetouch_expandable( true )
		spHor.yk_set_divider_location( 0.25 )
		spVer.yk_set_divider_location( 0.25 )

		basePan = YKLookPanelFlow.new()
		basePan.yk_add( spVer )
		yk_add( basePan )

		tree.yk_set_select_mode( 'S' )
		text.yk_set_editable( false )
		text.yk_set_wrap_style_word( false )

		tree .yk_set_listener( :fn_treeClicked  )
		table.yk_set_listener( :fn_tableClicked )

		tree .yk_set_tag( 'tree'  )
		table.yk_set_tag( 'table' )
		text .yk_set_tag( 'text'  )

		yk_var( '@filelist' )
	end

	def fn_treeClicked( prm_event )
		@filelist = fn_filelist()
		itemdata  = fn_itemdata( @filelist )
		yk_look( 'table' ).yk_set_item_data( itemdata )
		yk_look( 'text'  ).yk_set_text( '' )
	end
	def fn_filelist()
		nodepath = yk_look( 'tree' ).yk_selected_node()[0]
		if nodepath[-1] == 'Mς'
			return ["masaoka-shiki-01.txt",
					"tsuda-seifu-01.txt",
					"kimura-genjo-01.txt" ]
		end
		if nodepath[-1] == 'M'
			return ["masaoka-shiki-02.txt",
					"masaoka-shiki-03.txt" ]
		end
		if nodepath[-1] == 'Ƒ/e'
			return ["nakane-rin-01.txt" ]
		end
		if nodepath[-1] == 'q'
			return ["kyoko-01.txt",
					"kyoko-02.txt",
					"kyoko-03.txt",
					"kyoko-04.txt",
					"kyoko-05.txt" ]
		end
		if nodepath[-1] == 'k/剺'
			return ["terada-torahiko-01.txt",
					"terada-torahiko-02.txt",
					"takahama-kyoshi-01.txt",
					"komiya-toyotaka-01.txt",
					"matsune-toyojo-01.txt",
					"nogami-toyoichiro-01.txt",
					"suzuki-miekichi-01.txt",
					"terada-torahiko-03.txt",
					"komiya-toyotaka-02.txt" ]
		end
		if nodepath[-1] == '̑'
			return ["monbu-sho-01.txt" ]
		end

		return nil
	end
	def fn_itemdata( prm_filelist )
		ary = []
		if prm_filelist.nil?()
			return ary
		end
		prm_filelist.each() do |filename|
			item = fn_file_contents( filename, false )
			ary << [ item[0], item[2], item[1] ]
		end
		return ary
	end
	def fn_file_contents( prm_filename, prm_need_body )
		item = []
		f = nil
		begin
			f = File.open( prm_filename )
			item << f.readline().chomp()
			item << f.readline().chomp()
			item << f.readline().chomp()
			if prm_need_body
				item << f.read()
			end
		rescue
			item << '?' << '?' << '?' << '?'
		end
		if f
			f.close()
		end
		return item
	end
	def fn_tableClicked( prm_event )
		rowindex = yk_look( 'table' ).yk_selected_row()[0]
		str = ''
		if @filelist
			if 0 <= rowindex and rowindex < @filelist.size()
				item = fn_file_contents( @filelist[rowindex], true )
				str  = item[3]
			end
		end
		yk_look( 'text' ).yk_set_text( str )
	end

	def yki_laf_is_system()
		return false
	end
	# def yki_fr_need_pack()
	#	return true
	# end
	# def yki_ht_farpath()
	#	return [ '/tools' , nil ]
	# end
end

YKLookMain.yk_mainloop( Tegami.new() )

#
# end of program
